# $Header:   //archive/pvcsroot/archive_nls/scripts/fix_clprocess.ksv   1.0   Aug 15 2001 17:04:08   Forthman  $

# Goal:  alter the UPDATE statements in the cl_process<CID> stored procedure so that they do not reference
#        use the table alias v.
# usage: fix_clprocess.ksh <filename>

filenameSource=$1
filenameTemp=$0.$$.temp

cp $filenameSource $filenameTemp

awk '

BEGIN { bInProc = 0 }

/^CREATE PROCEDURE cl_/ { bInProc = 1 }
(bInProc == 1 ) && /^[[:space:]]*UPDATE[[:space:]]*[^[:space:]]*[[:space:]]*SET v\./ { sub( "v\.", "", $0) }
(bInProc == 1 ) && /^GO/ { bInProc = 0 }
// { print $0 }

' $filenameTemp > $filenameSource

rm -f $filenameTemp
