# $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/Scripts/imPopulateSeedtable.ksv   1.8   Aug 30 2001 11:49:44   lin  $
# $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/Scripts/imPopulateSeedtable.ksv  $
# $Revision:   1.8  $
# $Date:   Aug 30 2001 11:49:44  $
# $Author:   lin  $
#!/bin/sh
#set -x
#
localhost="$(print "$COMPUTERNAME" | awk '{print toupper($0);}')"

INSTALLDIR=$(regfind -p "HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0" -n "InstallDirectory" 2>nul: | grep InstallDirectory | sed 's/[ ]*InstallDirectory = //' | sed 's?\\?/?g' | sed 's/\/$//g') 

#if [ ! -d "$INSTALLDIR" ]; then
#  print >&2 "Invalid installation directory: $INSTALLDIR"
#  print >&2 "Tivoli Business Systems Manager is not installed on this system"
#  exit 1
#fi

eval `regdmp "HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0\Settings\DB" | awk '/Server/ {printf("db_server=%s\n",$3);} /User/ {printf("db_user=%s\n",$3);} /Password/ {printf("db_password=%s\n",$3);}'`

if [ -z $db_server ] || [ -z $db_user ] || [ -z $db_password ]; then
  print >&2 "TBSM SQL Server is not set up on this system"
  exit 1
fi

db_server=$(echo $db_server | awk '{print toupper($0);}')

if [ "$db_server" != "$localhost" ]; then
  print >&2 "Please run $0 on TBSM SQL Server $db_server"
  exit 1
fi

usage   ()
{
  print ''
  print 'Usage: '$0' [options...]'
  print ''
  print '  -S<db_server>           Specifies server name where database resides.  Default=['$db_server'].'
  print '  -U<db_user>             Specifies database user name.  Default=['$db_user'].'
  print '  -P<db_password>         Specifies password for database user.  Default=['$db_password'].'
  print '  -E                      Use trusted database connection. Use this instead of -U<username> and -P<password>'
  print ''
  print ''
}

while getopts "U:S:P:Eh?" c; do
  case $c in
  U)  db_user=$OPTARG;;
  S)  db_server=$(echo $OPTARG | awk '{print toupper($0);}');;
  P)  db_password=$OPTARG;;
  E)  bTrusted=1;;
  h)  usage; exit 1;;
  \?) usage; exit 1;;
  *)  print >&2 Error with option $OPTOPT; usage; exit 1;;
  esac
done

#
if [ "$bTrusted" -eq 1 ]; then
  #SQLCMD="tbsmsql -S$db_server -E -n -w3000 "
  SQLCMD="osql -h-1 -S$db_server -E -n -w3000 "
else
  #SQLCMD="tbsmsql -S$db_server -U$db_user -P$db_password -n -w3000 "
  SQLCMD="osql -h-1 -S$db_server -U$db_user -P$db_password -n -w3000 "
fi

$SQLCMD -Q"SET NOCOUNT ON; SELECT name FROM master..sysdatabases ORDER BY name" |  egrep -v '^[-[:space:]]*$' | while read db; do 
  if [ -z $db ]; then
    continue;
  fi

  if [ "$db" == "ASIRuleSvc" ] || 
    [ "$db" == "EventHistory" ] || 
    [ "$db" == "Meta" ] ||
    [ "$db" == "Object" ] || 
    [ "$db" == "ObjectEvents" ] || 
    [ "$db" == "ObjectQueues" ] ||
    [ "$db" == "OPCLoad" ] || 
    [ "$db" == "RODM" ] || 
    [ "$db" == "RODMLoad" ] || 
    [ "$db" == "WebServer" ] ||
    [ "$db" == "master" ] ||
    [ "$db" == "msdb" ]; then

    sql_cmd="IF NOT EXISTS (SELECT * FROM imObjectSeed WHERE host = '$localhost' AND path = '$db')
      INSERT INTO imObjectSeed VALUES (N'$localhost', N'DB', N'$db', 1)
    "
    $SQLCMD -d'Object' -Q"$sql_cmd"
  fi

done

INSTALLDIR=$(echo $INSTALLDIR | sed 's/:/\$/')
sql_cmd="IF NOT EXISTS (SELECT * FROM imObjectSeed WHERE host = '$localhost' AND path = '$INSTALLDIR')
  INSERT INTO imObjectSeed VALUES (N'$localhost', N'FS', N'$INSTALLDIR', 1)
  "
$SQLCMD -d'Object' -Q"$sql_cmd"
