     @echo off
@rem ***************************************************************************
@rem * Licensed Materials - Property of IBM
@rem * 5698-BSM
@rem * (C) COPYRIGHT Tivoli Systems, an IBM Company 1998, 2000
@rem * All rights reserved
@rem *
@rem * US Government Users Restricted Rights - Use, duplication or
@rem * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@rem ***************************************************************************

@rem ***************************************************************************
@rem * Setup the environment and execute the provided command
@rem ***************************************************************************
     @setlocal

     @if "%LANG%" == "" set LANG=C
     @if "%windir%" == "" goto ISOS2
     @if "%bindir%" == "" goto WINBINDR
     @if exist %bindir%\tools\nul goto TIVTOOL
     @goto TSTOOL

:WINBINDR
     @if not "%TSERVER_ETC%" == "" goto WINETC
     @if exist %windir%\system32\drivers\etc\Tivoli\setup_tbsm.cmd goto WINTBSM
     @if exist %windir%\system32\drivers\etc\Tivoli\setup_env.cmd goto WINTIV
     @goto FAILURE

:WINETC
     @if exist %TSERVER_ETC%\setup_tbsm.cmd goto WIN2TBSM
     @if exist %TSERVER_ETC%\setup_env.cmd goto WIN2TIV
     @goto FAILURE

:WIN2TBSM
     @call %TSERVER_ETC%\setup_tbsm.cmd
     @goto WINDONE

:WIN2TIV
     @call %TSERVER_ETC%\setup_env.cmd
     @goto WINDONE

:WINTBSM
     @call %windir%\system32\drivers\etc\Tivoli\setup_tbsm.cmd
     @goto WINDONE

:WINTIV
     @call %windir%\system32\drivers\etc\Tivoli\setup_env.cmd

:WINDONE
     @set T_SERVT=yes
     @if exist %bindir%\tools\nul goto TIVTOOL
     @goto TSTOOL

:ISOS2
     @if exist %bindir%\tools goto TIVTOOL
     @goto TSTOOL

:TSTOOL
     @if not exist %BINDIR%\TDS\EventService\msg_cat\%LANG%  set LANG=C
     @set PATH=%bindir%\TDS\EventService\tools;%bindir%\TDS\EventService\bin;%bindir%\TDS\EventService\msg_cat\%LANG%;%PATH%
     @set T_SERVP=yes
     @goto RUNCMD

:TIVTOOL
     @if not exist %BINDIR%\TDS\EventService\msg_cat\%LANG%  set LANG=C
     @set PATH=%bindir%\tools;%bindir%\TDS\EventService\bin;%bindir%\TDS\EventService\msg_cat\%LANG%;%PATH%
     @set T_SERVP=yes
     @goto RUNCMD

:FAILURE
     @echo "rc(5902) setup_env.cmd not found"
     @goto THEEND

:RUNCMD
     @if "%windir%" == "" goto SETOS2
     @if not exist %BINDIR%\TDS\EventService\msg_cat\%LANG%\modify_cp.cmd goto READY
     @call %BINDIR%\TDS\EventService\msg_cat\%LANG%\modify_cp.cmd
     @chcp %RET_CP%
     @goto READY

:SETOS2
     @set BEGINLIBPATH=%BINDIR%\TDS\EventService\bin;%BINDIR%\TDS\EventService\msg_cat\%LANG%;
     @set HELP=%HELP%;%BINDIR%\TDS\EventService\msg_cat\%LANG%;
     @set T_SERVT=yes

:READY
     @if "%1" == ""     goto USAGE

     @if %1 == service  goto CMDFILE
     @if %1 == SERVICE  goto CMDFILE
     @if %1 == ihszfmt  goto CMDFILE
     @if %1 == IHSZFMT  goto CMDFILE
     @if %1 == ihszset  goto CMDFILE
     @if %1 == IHSZSET  goto CMDFILE
     @if %1 == ihszsett goto CMDFILE
     @if %1 == IHSZSETT goto CMDFILE
     @goto SHFILE

:CMDFILE
     @call %bindir%\TDS\EventService\bin\%1 %2 %3 %4 %5 %6 %7 %8 %9
     @goto THEEND

:SHFILE
     @call sh %BINDIR%\TDS\EventService\bin\%1 %2 %3 %4 %5 %6 %7 %8 %9
     @goto THEEND

:USAGE
     @call %bindir%\TDS\EventService\bin\ihszmsgp 2 5910
     @call %bindir%\TDS\EventService\bin\ihszmsgp 2 5927

:THEEND

     @endlocal
