SET NOCOUNT ON
USE Object


-----------------------------------------------------------
IF EXISTS (select * from sysobjects where id = object_id(N'[dbo].[CL_RegistrationInstanceCkPt]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
  IF EXISTS (select * from syscolumns where id=OBJECT_ID(N'[dbo].[CL_RegistrationInstanceCkPt]') AND name='bcpFile') GOTO TABLEUPDATED
END


BEGIN TRAN abc

IF EXISTS (select * from sysobjects where id = object_id(N'[dbo].[CL_RegistrationInstanceCkPt]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
  select * into #CL_REG from CL_RegistrationInstanceCkPt
  drop table [dbo].[CL_RegistrationInstanceCkPt]
END

/****** Object:  Table [dbo].[CL_RegistrationInstanceCkPt]    Script Date: 8/18/01 11:05:04 AM ******/
CREATE TABLE [dbo].[CL_RegistrationInstanceCkPt] (
	[sidId] [int] NOT NULL ,
	[registrationId] [int] NOT NULL ,
	[trId] [int] NOT NULL ,
	[eventCount] [int] NOT NULL ,
	[trType] [int] NOT NULL ,
	[msgTr] [int] NOT NULL ,
	[msgNum] [int] NOT NULL ,
	[msgNumFinished] [int] NOT NULL ,
	[trInProgress] [bit] NOT NULL ,
	[trSafe] [bit] NOT NULL ,
	[longRunCount] [int] NOT NULL ,
	[aoc] [int] NOT NULL ,
	[doc] [int] NOT NULL ,
	[moc] [int] NOT NULL ,
	[alc] [int] NOT NULL ,
	[dlc] [int] NOT NULL ,
	[ec] [int] NOT NULL ,
	[state] [tinyint] NOT NULL ,
	[supportBulk] [bit] NOT NULL ,
	[supportDelta] [bit] NOT NULL ,
	[supportAtWill] [bit] NOT NULL ,
	[supportEvents] [bit] NOT NULL ,
	[supportMethods] [bit] NOT NULL ,
	[bcpFile] [nvarchar] (255) NULL ,
	[dateChange] [datetime] NOT NULL
) ON [PRIMARY]


ALTER TABLE [dbo].[CL_RegistrationInstanceCkPt] WITH NOCHECK ADD
	CONSTRAINT [DF_CL_RegistrationState_trId] DEFAULT (0) FOR [trId],
	CONSTRAINT [DF_CL_RegistrationState_eventCount] DEFAULT (0) FOR [eventCount],
	CONSTRAINT [DF_CL_RegistrationState_trType] DEFAULT (0) FOR [trType],
	CONSTRAINT [DF_CL_RegistrationState_msgTr] DEFAULT (0) FOR [msgTr],
	CONSTRAINT [DF_CL_RegistrationState_msgNum] DEFAULT (0) FOR [msgNum],
	CONSTRAINT [DF_CL_RegistrationInstance_msgNumFinished] DEFAULT (0) FOR [msgNumFinished],
	CONSTRAINT [DF_CL_RegistrationInstance_trInProgress] DEFAULT (0) FOR [trInProgress],
	CONSTRAINT [DF_CL_RegistrationInstance_trSafe] DEFAULT (1) FOR [trSafe],
	CONSTRAINT [DF_CL_RegistrationInstance_longRunCount] DEFAULT (0) FOR [longRunCount],
	CONSTRAINT [DF_CL_RegistrationState_aoc] DEFAULT (0) FOR [aoc],
	CONSTRAINT [DF_CL_RegistrationState_doc] DEFAULT (0) FOR [doc],
	CONSTRAINT [DF_CL_RegistrationState_moc] DEFAULT (0) FOR [moc],
	CONSTRAINT [DF_CL_RegistrationState_alc] DEFAULT (0) FOR [alc],
	CONSTRAINT [DF_CL_RegistrationState_dlc] DEFAULT (0) FOR [dlc],
	CONSTRAINT [DF_CL_RegistrationState_ec] DEFAULT (0) FOR [ec],
	CONSTRAINT [DF_CL_RegistrationState_state] DEFAULT (1) FOR [state],
	CONSTRAINT [DF_CL_RegistrationState_dateChange] DEFAULT (getdate()) FOR [dateChange]


IF EXISTS (select * from tempdb..sysobjects where id = object_id('tempdb..#CL_REG'))
BEGIN
  select * from #CL_REG
  if @@ROWCOUNT > 0
    INSERT into CL_RegistrationInstanceCkPt (sidId, registrationId, trId, eventCount, trType, msgTr, msgNum, msgNumFinished, trInProgress, trSafe, longRunCount, aoc, doc, moc, alc, dlc, ec, state, supportBulk, supportDelta, supportAtWill, supportEvents, supportMethods, dateChange)
    select * from #CL_REG
  drop table #CL_REG
END

COMMIT TRAN abc

TABLEUPDATED:


/*** Created by Radhikha ***/
-----------------------------------------------------------


PRINT 'Creating table CL_Severities'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_Severities' and type='U')
  DROP TABLE CL_Severities
GO

CREATE TABLE CL_Severities (
  name NVARCHAR(64) PRIMARY KEY(name, severity),
  severity NVARCHAR(32),
  excp_alertState INT,
  excp_priority INT,
  mesg_alertState INT,
  mesg_priority INT
)
GO

-- GEM Severities
INSERT CL_Severities SELECT 'tec', 'normal', 1, 5, 1, 4
INSERT CL_Severities SELECT 'tec', 'harmless', 1, 4, 1, 4
INSERT CL_Severities SELECT 'tec', 'informational', 1, 4, 1, 5
INSERT CL_Severities SELECT 'tec', 'unknown', 2, 5, 2, 4
INSERT CL_Severities SELECT 'tec', 'minor', 2, 4, 2, 4
INSERT CL_Severities SELECT 'tec', 'warning', 2, 3, 2, 3
INSERT CL_Severities SELECT 'tec', 'severe', 3, 3, 3, 3
INSERT CL_Severities SELECT 'tec', 'critical', 3, 2, 3, 2
INSERT CL_Severities SELECT 'tec', 'fatal', 3, 1, 3, 1

-- NetView Severities
INSERT CL_Severities SELECT 'nvd', 'unknown', 1, 5, 1, 4
INSERT CL_Severities SELECT 'nvd', 'normal', 1, 5, 1, 4
INSERT CL_Severities SELECT 'nvd', 'marginal', 2, 3, 2, 3
INSERT CL_Severities SELECT 'nvd', 'critical', 3, 1, 3, 1
INSERT CL_Severities SELECT 'nvd', 'unmanaged', 1, 5, 1, 4
INSERT CL_Severities SELECT 'nvd', 'acknowledged', 1, 5, 1, 4
INSERT CL_Severities SELECT 'nvd', 'user1', 1, 5, 1, 4
INSERT CL_Severities SELECT 'nvd', 'user2', 2, 3, 2, 3
INSERT CL_Severities SELECT 'nvd', 'unreachable', 1, 5, 1, 4

-- TNG Severities
INSERT CL_Severities SELECT 'tng', 'unknown', 2, 5, 2, 4
INSERT CL_Severities SELECT 'tng', 'normal', 1, 5, 1, 4
INSERT CL_Severities SELECT 'tng', 'minor', 2, 4, 2, 4
INSERT CL_Severities SELECT 'tng', 'major', 2, 2, 2, 2
INSERT CL_Severities SELECT 'tng', 'warning', 2, 3, 2, 3
INSERT CL_Severities SELECT 'tng', 'critical', 3, 2, 3, 2
INSERT CL_Severities SELECT 'tng', 'inservice', 1, 4, 1, 4
INSERT CL_Severities SELECT 'tng', 'down', 3, 1, 3, 1
INSERT CL_Severities SELECT 'tng', 'remove', 2, 5, 2, 4
INSERT CL_Severities SELECT 'tng', 'future', 2, 5, 2, 4

GO


PRINT 'CL_TableUpdate Completed ...'
