-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/DEFECT_OW50409.sqv   1.0   Aug 10 2001 15:22:38   BRENT  $
--
-- DEFECT_OW50409.sql
--
-- Module Description
--   Resolves defect OW50409:
--   STAGED EVENT LOADER SERVICE GOES IN PAUSED STATE WHEN HTTP SERVER TASK STCS ARE INVOLVED

USE Object
GO

--- Disable the general IMW35* trap

UPDATE GenericTrapDescription_C SET _Enabled = 0
WHERE description = 'IMW3534-IMW3539 and IMW3540-IMW3542 messages' 

-- Add specific traps for each on the IMW messages we handle

EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3535E',
  @Enabled     = 1,
  @Description = 'IMW3535E - Server initialization failed'
EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3536I',
  @Enabled     = 1,
  @Description = 'IMW3536I - Server ready'
EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3537I',
  @Enabled     = 1,
  @Description = 'IMW3537I - Server restarting'
EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3538I',
  @Enabled     = 1,
  @Description = 'IMW3538I - Restart successful'
EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3539E',
  @Enabled     = 1,
  @Description = 'IMW3539E - Restart failed'
EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3540I',
  @Enabled     = 1,
  @Description = 'IMW3540I - Server stopping work'
EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3541I',
  @Enabled     = 1,
  @Description = 'IMW3541I - Server terminating now'
EXEC _DefineGenTrapDescription
  @cid         = ROOT,
  @id          = 0,
  @ParentCID   = 'ROOT',
  @ParentID    = 0,
  @Category    = 'IMW Console Messages',
  @MsgID       = 'IMW3542E',
  @Enabled     = 1,
  @Description = 'IMW3542E - Server dumping'
