-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/Process_GenericTrap_Event.sqv   1.2   Aug 07 2001 16:48:20   BRENT  $
--
-- Process_GenericTrap_Event.sql
--
-- Module Description
--   Defines the Process_GenericTrap_Event stored procdedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- Process_GenericTrap_Event
PRINT 'Creating procedure Process_GenericTrap_Event'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'Process_GenericTrap_Event' AND type = 'P')
  DROP PROCEDURE Process_GenericTrap_Event
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/Process_GenericTrap_Event.sqv  $
-- $Revision:   1.2  $
-- $Date:   Aug 07 2001 16:48:20  $
-- $Author:   BRENT  $
-- Event handler procedure for processing generic trap events.
CREATE PROCEDURE Process_GenericTrap_Event
  @SourceCID       ClassID,
  @SourceID        ObjID,
  @FormatType      SMALLINT,
  @ActionType      SMALLINT,
  @DATE_TIME       NVARCHAR(30),
  @SEQ_NO          NVARCHAR(50),
  @OBJ_TYPE_ID     NVARCHAR(50)=NULL,
  @OBJECT_NAME     NVARCHAR(50)=NULL,
  @NATIVE_KEY      NVARCHAR(10)=NULL,
  @PARM_1          NVARCHAR(10)=NULL,
  @MESSAGE         NVARCHAR(255)=NULL,
  @REASON_CD       NVARCHAR(2000)=NULL
AS
--  RAISERROR('Process_GenericTrap_Event: src_cid=%s, src_id=%ld, FormatType=%d, ActionType=%d, DATE_TIME=%s, SEQ_NO=%s, OBJ_TYPE_ID=[%s], OBJECT_NAME=[%s], NATIVE_KEY=[%s], PARM_1=[%s], MESSAGE=[%s], REASON_CD=[%s]', 0, 1, @SourceCID, @SourceID, @FormatType, @ActionType, @DATE_TIME, @SEQ_NO, @OBJ_TYPE_ID, @OBJECT_NAME, @NATIVE_KEY, @PARM_1, @MESSAGE, @REASON_CD)

  -- Standard transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN Process_GenericTrap_Event
  ELSE
    SAVE TRAN Process_GenericTrap_Event

  DECLARE @datetime DATETIME
  EXEC asisp_convertMVSDateTime @DATE_TIME, @datetime OUTPUT

  -- Insert into the staging table
--  RAISERROR('Process_GenericTrap_Event: inserting event into StagedGenericTrap', 0, 1)
  INSERT StagedGenericTrap(src_cid, src_id, DATE_TIME, SEQ_NO, OBJ_TYPE_ID, 
            OBJECT_NAME, NATIVE_KEY, PARM_1, MESSAGE, REASON_CD)
    SELECT  @SourceCID, @SourceID, @datetime, @SEQ_NO, @OBJ_TYPE_ID, 
            @OBJECT_NAME, @NATIVE_KEY, @PARM_1, @MESSAGE, @REASON_CD

  -- Finish up transaction
  IF @tcount = 0
    COMMIT TRAN Process_GenericTrap_Event
GO
