-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/ResetBatchClasses.sqv   1.1   Aug 09 2001 11:24:34   BRENT  $
--
-- ResetBatchClasses.sql
--
-- Module Description
--   Defines the ResetBatchClasses stored procedure

USE Object
GO

------------------------------------------------------------------------------------------------
-- ResetBatchClasses
PRINT 'Create procedure ResetBatchClasses'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'ResetBatchClasses' AND type = 'P')
  DROP PROCEDURE ResetBatchClasses
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/ResetBatchClasses.sqv  $
-- $Revision:   1.1  $
-- $Date:   Aug 09 2001 11:24:34  $
-- $Author:   BRENT  $
-- Resets batch-related classes
CREATE PROCEDURE ResetBatchClasses
AS
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION ResetBatchClasses
  ELSE
    SAVE TRANSACTION ResetBatchClasses

  DELETE lob
    FROM LineOfBusiness_C AS lob JOIN LOB_BCYS_LOBL AS lbl ON lob.id = lbl.src_id
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  DELETE lob
    FROM LineOfBusiness_C AS lob JOIN LOB_BTCY_LOBL AS lbl ON lob.id = lbl.src_id
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  DELETE lob
    FROM LineOfBusiness_C AS lob JOIN LOB_BATC_LOBL AS lbl ON lob.id = lbl.src_id
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  DELETE lbc
    FROM LOB_LOB_LOBC AS lbc
    WHERE NOT EXISTS (SELECT id FROM LineOfBusiness_C AS lob WHERE lob.id = lbc.dst_id)
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  DELETE opc_predecessor
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  DELETE opc_operation
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  DELETE opc_application
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  DELETE opc_daily_plan
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRANSACTION ResetBatchClasses
    RETURN -30000
  END

  IF @tcount = 0
    COMMIT TRANSACTION ResetBatchClasses

  EXEC asisp_resetclass BATC, BATCH
  EXEC asisp_resetclass BTCY, BatchCycle
  EXEC asisp_resetclass BCYS, BatchCycles

  
  DELETE c FROM Message_C AS c JOIN Message_A AS a ON a.id = c.id WHERE a._ParentCID = 'BATC'
  DELETE c FROM Exception_C AS c JOIN Exception_A AS a ON a.id = c.id WHERE a._ParentCID = 'BATC'
  DELETE c FROM ExceptionHistory_C AS c JOIN ExceptionHistory_A AS a ON a.id = c.id 
    WHERE a._ParentID NOT IN (SELECT id FROM Exception_C)
  DELETE c FROM BatchCycleJobHist AS c
  DELETE c FROM event AS c WHERE obj_cid = 'BATC'
GO
