-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/StagedGenericTrap.sqv   1.0   Aug 07 2001 16:49:16   BRENT  $
--
-- StagedGenericTrap.sql
--
-- Module Description
--   Defines the StagedGenericTrap table

USE Object
GO

---------------------------------------------------------------------------------------------------
-- StagedGenericTrap

IF NOT EXISTS (SELECT * FROM sysobjects WHERE name = 'StagedGenericTrap' AND type = 'U')
BEGIN
  PRINT 'Creating table StagedGenericTrap'

  CREATE TABLE StagedGenericTrap
  (
    timestamp                     timestamp  NOT NULL,
    ctime                         DATETIME  NULL CONSTRAINT SGT_ctime_DF DEFAULT (CURRENT_TIMESTAMP),
    src_cid                       ClassID  NOT NULL,
    src_id                        ObjID  NOT NULL,
    DATE_TIME                     DATETIME  NULL,
    SEQ_NO                        NVARCHAR(50) NULL,
    OBJ_TYPE_ID                   NVARCHAR(50) NULL,
    OBJECT_NAME                   NVARCHAR(50) NULL,
    NATIVE_KEY                    NVARCHAR(10) NULL,
    PARM_1                        NVARCHAR(10) NULL,
    MESSAGE                       NVARCHAR(255) NULL,
    REASON_CD                     NVARCHAR(2000) NULL
  )
  ALTER TABLE StagedGenericTrap ADD CONSTRAINT StagedGenericTrap_PK PRIMARY KEY CLUSTERED(timestamp)
END

EXEC sp_dbcmptlevel Object, 70
GO

IF (SELECT prec FROM syscolumns WHERE id = OBJECT_ID('StagedGenericTrap') AND name = 'REASON_CD') = 255
BEGIN
  PRINT 'Expanding StagedGenericTrap.REASON_CD to 2000 characters'
  EXEC("
  ALTER TABLE StagedGenericTrap ALTER COLUMN REASON_CD NVARCHAR(2000) NULL
  ")
END

EXEC sp_dbcmptlevel Object, 65
GO
