-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/alloc_FILE.sqv   1.2   Aug 08 2001 11:49:54   BRENT  $
--
-- alloc_FILE.sql
--
-- Module Description
--   Defines the alloc_FILE stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- alloc_FILE
PRINT 'Creating procedure alloc_FILE'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'alloc_FILE' AND type = 'P')
  DROP PROCEDURE alloc_FILE
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/alloc_FILE.sqv  $
-- $Revision:   1.2  $
-- $Date:   Aug 08 2001 11:49:54  $
-- $Author:   BRENT  $
-- modified for better performance on bulk creation
CREATE PROCEDURE alloc_FILE
  @count    INT=1
AS
  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION alloc_FILE
  ELSE
    SAVE TRANSACTION alloc_FILE

  DECLARE @last_id INT
  SELECT @last_id=last_id+1 FROM FILE_ID WITH (TABLOCKX)
  
  UPDATE FILE_ID SET last_id=last_id+@count

  IF @tcount = 0
    COMMIT TRANSACTION alloc_FILE

  RETURN @last_id
GO
