-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/alloc_TRAN.sqv   1.1   Aug 18 2001 10:32:00   Xiaoyan  

-- alloc_TRAN.sql

-- Module Description
--   Defines alloc_TRAN stored procedure

USE Object
GO

---------------------------------------------------------------------------------------------------------------
-- alloc_TRAN
PRINT 'Creating alloc_TRAN procedure....'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE name = 'alloc_TRAN' AND type = 'P')
  DROP PROCEDURE alloc_TRAN
GO 

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/alloc_TRAN.sqv  $
-- $Revision:   1.1  $
-- $Date:   Aug 18 2001 10:32:00  $
-- $Author:   Xiaoyan  $
-- modified for better performance on bulk creation
CREATE PROCEDURE alloc_TRAN
  @count    INT=1
AS
  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION alloc_TRAN
  ELSE
    SAVE TRANSACTION alloc_TRAN

  DECLARE @last_id INT
  SELECT @last_id=last_id+1 FROM TRAN_ID WITH (TABLOCKX)
  
  UPDATE TRAN_ID SET last_id=last_id+@count

  IF @tcount = 0
    COMMIT TRANSACTION alloc_TRAN

  RETURN @last_id
GO
