-- as_getLocalizedString
--
-- Defect 80850 Data missing from Managed Objects view in Japanese
--

print 'Creating procedure as_getLocalizedString'
go

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'as_getLocalizedString' AND type = 'P')
  DROP PROCEDURE as_getLocalizedString
go

--
-- This procedure performs the same function as asisp_getLocalizedString
-- when used to lookup a specific string.  The difference is this proc
-- returns the result in a result set rather than as a return scalar.
-- It appears that JDBC does not handle double byte strings
-- correctly in a scalar result.
--
CREATE PROCEDURE as_getLocalizedString
    @key_name         sysname,
    @english_string   VARCHAR(128)
AS
  DECLARE @local_string NVARCHAR(255)
  -- Call the proc to lookup value.
  EXEC asisp_getLocalizedString @key_name, @english_string, @local_string OUTPUT, NULL
  -- Return the localized string in result set so JDBC handles DBCS correctly
  SELECT @local_string AS 'local_string'

go
