-- $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/sql/asisp_createMADRByCid.sqv   1.1   Aug 22 2001 17:41:58   Forthman  $
-- asisp_createMADRByCid
--
-- Module Description
--   stored procedure asisp_createMADRByCid

Use Object
GO

-----------------------------------------------------------
PRINT 'create procedure asisp_createMADRByCid'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_createMADRByCid' AND type = 'P' )
  DROP PROCEDURE asisp_createMADRByCid
GO

-- Goal: Create a MADR object if needed for a pre-existing cid
CREATE PROCEDURE asisp_createMADRByCid
  @cid ClassID
AS
  -- Normal transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION asisp_createMADRByCid
  ELSE
    SAVE TRANSACTION asisp_createMADRByCid

  SET NOCOUNT ON

  RAISERROR( 'asisp_createMADRByCid @cid = ''%s''', 0, 1, @cid)

  -- for each non deleted instance of a class check for MADR, if none then create
  DECLARE @tablename NVARCHAR(256)
  SELECT  @tablename = cname + '_V' FROM obj_class WHERE cid = @cid

  DECLARE @sql NVARCHAR(2000)
  SELECT @sql = '
  DECLARE o CURSOR FOR 
    SELECT id FROM ' + @tablename + ' AS o 
    INNER JOIN link AS l ON l.dst_cid = ''' + @cid + ''' AND l.dst_id = o.id
    WHERE l.deleted = 0
      AND NOT EXISTS ( SELECT * FROM MVSAddressSpace_V WHERE _InstanceCID = ''' + @cid + ''' AND _InstanceID = o.id AND deleted = 0)
  OPEN o
  DECLARE @id ObjID
  FETCH NEXT FROM o INTO @id
  WHILE @@FETCH_STATUS <> -1 
  BEGIN 
    EXEC asisp_createMADRByCidId ''' + @cid + ''', @id
    FETCH NEXT FROM o INTO @id
  END
  CLOSE o
  DEALLOCATE o'
  
  EXEC ( @sql )

  -- Normal transaction logic
  IF @tcount = 0
    COMMIT TRANSACTION asisp_createMADRByCid

GO