-- $Header
-- asisp_createObjPumpMsg_ACC0225.sql
-- 
-- Module Description
--   create procedure asisp_createObjPumpMsg_ACC0225
--

Use Object
GO

--------------------------------------------------------------------------
-- asisp_createObjPumpMsg_ACC0225

PRINT 'create procedure asisp_createObjPumpMsg_ACC0225'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_createObjPumpMsg_ACC0225' AND type = 'P' )
  DROP PROCEDURE asisp_createObjPumpMsg_ACC0225
GO

-- $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/sql/asisp_createObjPumpMsg_ACC0225.sqv  $
-- $Revision:   1.2  $
-- $Date:   Aug 24 2001 15:01:50  $
-- $Author:   Forthman  $
CREATE PROCEDURE asisp_createObjPumpMsg_ACC0225
  @os_id          ObjID,
  @os_name        ObjName,
  @DATETIME       DATETIME,      -- 00
  @SEQ_NO         NVARCHAR(50),   -- 01
  @OBJECT_NAME    NVARCHAR(30),   -- 03
  @MESSAGE        NVARCHAR(255),  -- 46
  @PROGRAM_NAME   NVARCHAR(255) = '',  -- 80
  @MESSAGE_STATUS NVARCHAR(255) = '',  -- 81
  @PARM_1        NVARCHAR(255) = '',  -- 73
  @PARM_2        NVARCHAR(255) = '',  -- 74
  @PARM_3        NVARCHAR(255) = '',  -- 75
  @PARM_4        NVARCHAR(255) = '',  -- 76
  @PARM_5        NVARCHAR(255) = '',  -- 77
  @PARM_6        NVARCHAR(255) = '',  -- 78
  @PARM_7        NVARCHAR(255) = ''   -- 79
AS 
  DECLARE @dt NVARCHAR(255)
  SELECT @dt=CONVERT(NVARCHAR(255),@DATETIME)
  RAISERROR('asisp_createObjPumpMsg_ACC0225: @MESSAGE=%s, @OBJECT_NAME=%s, @SEQ_NO=''%s'', @DATETIME=''%s''', 0, 1, @MESSAGE, @OBJECT_NAME, @SEQ_NO, @dt)
  -- Standard TRANSACTION logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN asisp_createObjPumpMsg_ACC0225
  ELSE
    SAVE TRAN asisp_createObjPumpMsg_ACC0225
  DECLARE @obj_name  ObjName
  DECLARE @omeg_type NVARCHAR(255)
  DECLARE @appl_id   NVARCHAR(255)
  SELECT @omeg_type=@PARM_1, @obj_name=@PARM_2, @appl_id=@PARM_3
  -- determine the object's @cid FROM @omeg_type (Omegamon-Type)
  DECLARE @cid ClassID
  DECLARE @id  ObjID
  SELECT @cid=CASE @omeg_type 
                WHEN 'OMMVS'  THEN 'OS'
                WHEN 'OMCICS' THEN 'CICS'
                WHEN 'OMDB2'  THEN 'DB2'
                WHEN 'OMIMS'  THEN 'IMS'
                ELSE NULL
              END
  -- Handle D2SS case, we may recieve either events for DB2 or D2SS as OMDB2
  --   If the name matches a D2SS under the OS then change @cid
  IF EXISTS ( SELECT * FROM link AS l
  INNER JOIN DB2Subsystem_V AS o ON o.id = l.dst_id
  WHERE
        l.src_cid = 'OS'
    AND l.src_id  = @os_id
    AND l.dst_cid = 'D2SS'
    AND l.deleted = 0
    AND o.name    = @obj_name )
  BEGIN
    SELECT @cid = 'D2SS'
  END
  -- determine the object's @id FROM @obj_name (Object Name)
  IF @cid='OS'
    SELECT @id=@os_id
  ELSE
  BEGIN
    DECLARE @sql NVARCHAR(255)
    DECLARE @sql2 NVARCHAR(255)
    CREATE TABLE #id (id ObjID)
    SELECT @sql='INSERT #id(id) 
            SELECT id
            FROM '+cname+'_C, containment c
            WHERE name="'+@obj_name+'" '
      FROM obj_class 
      WHERE cid=@cid
    SELECT @sql2='
              AND src_cid="OS"
              AND src_id='+CONVERT(NVARCHAR(255),@os_id)+'
              AND dst_cid="'+RTRIM(@cid)+'"
              AND dst_id=id
              AND c.deleted=0'
    EXEC(@sql+@sql2)
    SELECT @id=id FROM #id
    DROP TABLE #id
  END
  -- sanity check
  IF @cid IS NULL OR @id IS NULL
  BEGIN
    -- cannot treat AS error AS IS FATAL to MVSEventHandler AND happens too often
    RAISERROR('asisp_createObjPumpMsg_ACC0225: ERROR - cannot determine object''s @cid OR @id FROM omegamon-type[%s], name[%s]', 0, 1, @omeg_type, @obj_name)
    ROLLBACK TRAN asisp_createObjPumpMsg_ACC0225
    RETURN 0
  END
  -- form the native key
  DECLARE @nativekey NVARCHAR(10)
  EXEC asisp_idtonativekey @cid, @id, @nativekey OUTPUT
  -- CREATE the description
  DECLARE @descr NVARCHAR(255)
  DECLARE @pm_descr NVARCHAR(255)
  EXEC asisp_getMVSPerfMonDescr @cid, @id, @pm_descr OUTPUT, @os_name
  SELECT @descr='Received ''Performance Monitor Login Failure (ACC0225)'' message FROM Source/390'
  IF @pm_descr IS NOT NULL
    SELECT @descr=@descr+'.  Omegamon(ApplID)= '''+@pm_descr+''''
  -- CREATE a message ON the target object
  RAISERROR('asisp_createObjPumpMsg_ACC0225: creating a Performance Monitor Login Failure message (ACC0225) ON the target %s-%d(%s)', 0, 1, @cid, @id, @obj_name)
  EXEC asisp_createMESG '', @cid, @id, @DATETIME, @DATETIME, 0, 
                        @SEQ_NO, '', @obj_name, @nativekey, '', 'ACC0225',
                        @descr
  -- find the OmegamonLogin object

  DECLARE @pmlg_id ObjID
  EXEC asisp_getMVSPMLoginObject @cid, @id, @pmlg_id OUTPUT
  IF @pmlg_id IS NULL
    RAISERROR('asisp_createObjPumpMsg_ACC0225: WARNING - received an Performance Monitor Login Failure (ACC0225) AND cannot find OmegamonLogin object.  @name=[%s], @cid=%s, @id=%d', 0, 1, @obj_name, @cid, @id)
  ELSE
  BEGIN
    -- mark resource AS 'disconnected' FROM Performance Monitor
    RAISERROR('asisp_createObjPumpMsg_ACC0225: marking resource AS ''disconnected'' FROM Performance Monitor. @name=[%s] @cid=%s, @id=%d', 0, 1, @obj_name, @cid, @id)
    UPDATE OmegamonLogin_A SET _LastOmegamonStatus=0 WHERE id=@pmlg_id
  END
  -- Finish up TRANSACTION
  IF @tcount = 0
    COMMIT TRAN asisp_createObjPumpMsg_ACC0225
  RETURN 0
GO
