PRINT 'Creating procedure cl_getLocalTime'

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_getLocalTime')
  DROP PROCEDURE cl_getLocalTime
GO

CREATE PROCEDURE cl_getLocalTime
@time NVARCHAR(255),
@tout DATETIME OUTPUT
AS

  RAISERROR('cl_getLocalTime: @time=%s, @disp OUT', 0, 1, @time)
  SET @tout = GETDATE()

  -- If @time is int, its assumed to be the value in seconds from epoch 
  IF ISNUMERIC(@time) = 1 BEGIN
    DECLARE @deltaGMT INT, @basetime DATETIME, @time_local INT
    
    -- get difference between LOCAL and GMT time from registry
    EXEC master.dbo.xp_regread 'HKEY_LOCAL_MACHINE',
    			       'SYSTEM\CurrentControlSet\Control\TimeZoneInformation',
			       'ActiveTimeBias', 
			       @deltaGMT OUTPUT
    
    --- Adjust base epoch time from the local time to the gmt at that time 
    SET @basetime = DATEADD(minute, (-@deltaGMT), 'Jan 01 1970 00:00:00')
   
/* if was a mistake to change the delta time with the delta value 
   this is what the code use to say ... 
    -- Convert @time from GMT to local and add base with @time
    SET @time_local = CAST(@time AS INT) - (@deltaGMT*60)
    
*/
    SET @time_local = CAST(@time AS INT)
    
    SET @tout = DATEADD(ss, @time_local, @basetime)  
  END





