PRINT 'Creating procedure cl_notifyLinkChanges'

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_notifyLinkChanges')
  DROP PROCEDURE cl_notifyLinkChanges
GO

CREATE PROCEDURE cl_notifyLinkChanges
AS
  -- input in #linkChanges
  /*
    CREATE TABLE #linkChanges (
      type NVARCHAR(4),
      src_cid ClassID,
      src_id ObjID,
      dst_cid ClassID,
      dst_id ObjID,
      action_type sysname
    )
  */
  RAISERROR('asisp_notifyLinkChanges: ', 0, 1)
 
  CREATE TABLE #notifyLinkChange (
    event_type INT,
    link_type NVARCHAR(4),
    fields NVARCHAR(255),
    src_cno SMALLINT,
    src_id ObjID,
    dst_cno SMALLINT,
    dst_id ObjID,
    flags INT,    
  )

  INSERT #notifyLinkChange(event_type, src_cno, src_id, dst_cno, dst_id, link_type, flags) 
    SELECT et.type, src.cno, lc.src_id, dst.cno, lc.dst_id, lc.type, lt.flags
    FROM EventType et, link_type lt, obj_class src, obj_class dst, #linkChanges lc
    WHERE et.name=lc.action_type AND src.cid=lc.src_cid AND dst.cid=lc.dst_cid AND lt.link_type=lc.type

  -- Delete Error cases
  DELETE FROM #notifyLinkChange 
    WHERE event_type IS NULL OR flags IS NULL OR src_cno IS NULL OR dst_cno IS NULL 

  -- Compute fields
  UPDATE #notifyLinkChange 
    SET fields = link_type + '|' + 
	         CONVERT(NVARCHAR(9), ISNULL(src_cno, 0))  + '|' +
	         CONVERT(NVARCHAR(9), ISNULL(src_id, 0))   + '|' +
	         CONVERT(NVARCHAR(9), ISNULL(dst_cno, 0))  + '|' +
	         CONVERT(NVARCHAR(9), ISNULL(dst_id, 0))   + '|' +
    	         CONVERT(NVARCHAR(9), ISNULL(flags, 0))

  INSERT PendingNotification(type, fields, detail) 
    SELECT event_type, fields, '' FROM #notifyLinkChange
