SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[gemsp_cmdSh]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[gemsp_cmdSh]
GO


CREATE PROCEDURE gemsp_cmdSh
@cmd NVARCHAR(255),
@matches TINYINT = 0 OUTPUT
AS
  RAISERROR('gemsp_cmdSh: @cmd=%s, @matches=%d OUT', 0, 1, @cmd, @matches)

  -- Keep xp_cmdshell call 'out' of the transaction logic as the database locks 
  -- tables associated with the transaction while it is waiting on the blocking 
  -- call to complete

  DECLARE @print_string NVARCHAR(1024)

  CREATE TABLE #results
  (
    line  NVARCHAR(512) NULL
  )

  DECLARE @result INT
  INSERT #results 
    EXEC @result = master..xp_cmdshell @cmd

  IF @result=0 AND EXISTS (SELECT * FROM #results)
    SELECT @matches = 1
  ELSE
    SELECT @matches = 0
    
  SET @print_string = 'TBSM4000I: Output for command: ' + @cmd
  EXEC gemsp_print @print_string
  SELECT * FROM #results

  RETURN @result

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

